from http.server import BaseHTTPRequestHandler, HTTPServer
import urllib
import time
from influxdb import InfluxDBClient
import sys
import csv
from datetime import datetime
###########################
#    SCRIPT SETTINGS
###########################
# Set the port where you want the bridge service to run
PORT_NUMBER = 1234
# InfluxDB Server parameters
INLUXDB_SERVER_IP = '192.168.1.210'
INLUXDB_SERVER_PORT = 8086
INFLUXDB_USERNAME = 'eleves'
INFLUXDB_PASSWORD = 'SmarthouseG2Elab'
INFLUXDB_DB_NAME = 'jeedom'
###########################

client = InfluxDBClient(INLUXDB_SERVER_IP, INLUXDB_SERVER_PORT, INFLUXDB_USERNAME, INFLUXDB_PASSWORD, INFLUXDB_DB_NAME)

print(client.get_list_database())

client.switch_database('jeedom')

#### Timestamps in seconds ###########"
timestamp_start= 1640300400 ## timestamp of the begin of period required (in second use https://www.epochconverter.com/)
timestamp_end= 1640991600   ## timestamp of the end of period required (in second use https://www.epochconverter.com/)

#### Convertion of timestamp to datetime
dt_object_start = datetime.fromtimestamp(timestamp_start)
print(dt_object_start)
dt_object_end = datetime.fromtimestamp(timestamp_end)
print(dt_object_end)

bind_params = {'end_time': str(dt_object_end), 'start_time': str(dt_object_start)}

datasheet = client.query('SELECT "value" FROM "jeedom"."autogen"."3888" WHERE time >= $start_time AND time < $end_time',bind_params=bind_params)

print(datasheet)

exported_data = list(datasheet.get_points())
header_list = list(exported_data[0].keys())

with open("noise_hiver.csv", "w", newline='') as fp:
    writer = csv.writer(fp, dialect='excel')
    print(header_list[1:])
    value_header = header_list[1]
    offset = sum(c.isalpha() for c in value_header)
    print(offset)
    #header_list[1:] = sorted(header_list[1:], key=lambda x: int(x[offset:]))
    header_list[1:] = ['value']
    # print(header_list)
    writer.writerow(header_list)
    for line in exported_data:
        # print(line)
        writer.writerow([line[kn] for kn in header_list])


