import pandas as pd
from sklearn import tree
from sklearn.model_selection import train_test_split
import matplotlib.pyplot as plt

import datetime
import time
import numpy as np
from sklearn.cluster import KMeans

CO2_salon_ete= pd.read_csv('CO2_salon_ete.csv', sep=',')
CO2_chambre_ete= pd.read_csv('CO2_chambre_ete.csv', sep=',')
T_salon_ete= pd.read_csv('T_salon_ete.csv', sep=',')
T_chambre_ete= pd.read_csv('T_chambre_ete.csv', sep=',')
H_salon_ete=pd.read_csv('H_salon_ete.csv', sep=',')
H_chambre_ete=pd.read_csv('H_chambre_ete.csv', sep=',')
noise_ete=pd.read_csv('noise_ete.csv', sep=',')

CO2_salon_hiver= pd.read_csv('CO2_salon_hiver.csv', sep=',')
CO2_chambre_hiver= pd.read_csv('CO2_chambre_hiver.csv', sep=',')
T_salon_hiver= pd.read_csv('T_salon_hiver.csv', sep=',')
T_chambre_hiver= pd.read_csv('T_chambre_hiver.csv', sep=',')
H_salon_hiver=pd.read_csv('H_salon_hiver.csv', sep=',')
H_chambre_hiver=pd.read_csv('H_chambre_hiver.csv', sep=',')
noise_hiver=pd.read_csv('noise_hiver.csv', sep=',')

def stringdate_to_datetime(stringdatetime: str): #fonction qui permet de modifier l'écriture de chaque instant (retirer les caractères inutiles)
    if "." in stringdatetime:
        stringdatetime=stringdatetime.split(".")[0]
    else:
        stringdatetime=stringdatetime.split("Z")[0]
    
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))

#On applique la fonction ci-dessus à toute nos données.

CO2_salon_ete["datetime"]=CO2_salon_ete["time"].apply(stringdate_to_datetime)
CO2_salon_ete.rename(columns={'value': 'CO2 salon ete'}, inplace=True)
CO2_chambre_ete["datetime"]=CO2_chambre_ete["time"].apply(stringdate_to_datetime)
CO2_chambre_ete.rename(columns={'value': 'CO2 chambre ete'}, inplace=True)

T_salon_ete["datetime"]=T_salon_ete["time"].apply(stringdate_to_datetime)
T_salon_ete.rename(columns={'value': 'T salon ete'}, inplace=True)
T_chambre_ete["datetime"]=T_chambre_ete["time"].apply(stringdate_to_datetime)
T_chambre_ete.rename(columns={'value': 'T chambre ete'}, inplace=True)

H_salon_ete["datetime"]=H_salon_ete["time"].apply(stringdate_to_datetime)
H_salon_ete.rename(columns={'value': 'H salon ete'}, inplace=True)
H_chambre_ete["datetime"]=H_chambre_ete["time"].apply(stringdate_to_datetime)
H_chambre_ete.rename(columns={'value': 'H chambre ete'}, inplace=True)

noise_ete["datetime"]=noise_ete["time"].apply(stringdate_to_datetime)
noise_ete.rename(columns={'value': 'noise ete'}, inplace=True)

CO2_salon_hiver["datetime"]=CO2_salon_hiver["time"].apply(stringdate_to_datetime)
CO2_salon_hiver.rename(columns={'value': 'CO2 salon hiver'}, inplace=True)
CO2_chambre_hiver["datetime"]=CO2_chambre_hiver["time"].apply(stringdate_to_datetime)
CO2_chambre_hiver.rename(columns={'value': 'CO2 chambre hiver'}, inplace=True)

T_salon_hiver["datetime"]=T_salon_hiver["time"].apply(stringdate_to_datetime)
T_salon_hiver.rename(columns={'value': 'T salon hiver'}, inplace=True)
T_chambre_hiver["datetime"]=T_chambre_hiver["time"].apply(stringdate_to_datetime)
T_chambre_hiver.rename(columns={'value': 'T chambre hiver'}, inplace=True)

H_salon_hiver["datetime"]=H_salon_hiver["time"].apply(stringdate_to_datetime)
H_salon_hiver.rename(columns={'value': 'H salon hiver'}, inplace=True)
H_chambre_hiver["datetime"]=H_chambre_hiver["time"].apply(stringdate_to_datetime)
H_chambre_hiver.rename(columns={'value': 'H chambre hiver'}, inplace=True)

noise_hiver["datetime"]=noise_hiver["time"].apply(stringdate_to_datetime)
noise_hiver.rename(columns={'value': 'noise hiver'}, inplace=True)

mergeData_ete=[CO2_salon_ete,CO2_chambre_ete,T_salon_ete,T_chambre_ete,H_salon_ete,H_chambre_ete,noise_ete]
result_ete=pd.concat(mergeData_ete, axis=1, join='inner')

mergeData_hiver=[CO2_salon_hiver,CO2_chambre_hiver,T_salon_hiver,T_chambre_hiver,H_salon_hiver,H_chambre_hiver,noise_hiver]
result_hiver=pd.concat(mergeData_hiver, axis=1, join='inner')

print(result_ete)
print(result_hiver)

# On arrange nos données pour que à chaque instant soit associé une série de donnée 

CO2_chambre_ete.set_index('datetime', inplace=True)
print("isnull",CO2_chambre_ete.isnull().any())
CO2_chambre_ete.ffill()
newCO2_chambre_ete=CO2_chambre_ete.resample('30T').mean()
print(newCO2_chambre_ete)

CO2_salon_ete.set_index('datetime',inplace=True)
print("isnull",CO2_salon_ete.isnull().any())
CO2_salon_ete.ffill()
newCO2_salon_ete=CO2_salon_ete.resample('30T').mean()
print(newCO2_salon_ete)

T_chambre_ete.set_index('datetime',inplace=True)
print("isnull",T_chambre_ete.isnull().any())
T_chambre_ete.ffill()
newT_chambre_ete=T_chambre_ete.resample('30T').mean()
print(newT_chambre_ete)

T_salon_ete.set_index('datetime',inplace=True)
print("isnull",T_salon_ete.isnull().any())
T_salon_ete.ffill()
newT_salon_ete=T_salon_ete.resample('30T').mean()
print(newT_salon_ete)

H_salon_ete.set_index('datetime',inplace=True)
print("isnull",H_salon_ete.isnull().any())
H_salon_ete.ffill()
newH_salon_ete=H_salon_ete.resample('30T').mean()
print(newH_salon_ete)

H_chambre_ete.set_index('datetime',inplace=True)
print("isnull",H_chambre_ete.isnull().any())
H_chambre_ete.ffill()
newH_chambre_ete=H_chambre_ete.resample('30T').mean()
print(newH_chambre_ete)

noise_ete.set_index('datetime',inplace=True)
print("isnull",noise_ete.isnull().any())
noise_ete.ffill()
newnoise_ete=noise_ete.resample('30T').mean()
print(newnoise_ete)


CO2_chambre_hiver.set_index('datetime', inplace=True)
print("isnull",CO2_chambre_hiver.isnull().any())
CO2_chambre_hiver.ffill()
newCO2_chambre_hiver=CO2_chambre_hiver.resample('30T').mean()
print(newCO2_chambre_hiver)

CO2_salon_hiver.set_index('datetime',inplace=True)
print("isnull",CO2_salon_hiver.isnull().any())
CO2_salon_hiver.ffill()
newCO2_salon_hiver=CO2_salon_hiver.resample('30T').mean()
print(newCO2_salon_hiver)

T_chambre_hiver.set_index('datetime',inplace=True)
print("isnull",T_chambre_hiver.isnull().any())
T_chambre_hiver.ffill()
newT_chambre_hiver=T_chambre_hiver.resample('30T').mean()
print(newT_chambre_hiver)

T_salon_hiver.set_index('datetime',inplace=True)
print("isnull",T_salon_hiver.isnull().any())
T_salon_hiver.ffill()
newT_salon_hiver=T_salon_hiver.resample('30T').mean()
print(newT_salon_hiver)

H_salon_hiver.set_index('datetime',inplace=True)
print("isnull",H_salon_hiver.isnull().any())
H_salon_hiver.ffill()
newH_salon_hiver=H_salon_hiver.resample('30T').mean()
print(newH_salon_ete)

H_chambre_hiver.set_index('datetime',inplace=True)
print("isnull",H_chambre_hiver.isnull().any())
H_chambre_hiver.ffill()
newH_chambre_hiver=H_chambre_hiver.resample('30T').mean()
print(newH_chambre_hiver)

noise_hiver.set_index('datetime',inplace=True)
print("isnull",noise_hiver.isnull().any())
noise_hiver.ffill()
newnoise_hiver=noise_hiver.resample('30T').mean()
print(newnoise_hiver)

"""hours=[]
for dt in fenetre2.datetime:
    hours.append(dt.hour)
fenetre2['hour']=hours"""

#On regroupe le tout dans un tableau
mergeData_ete=[newCO2_chambre_ete,newCO2_salon_ete,newT_salon_ete,newT_chambre_ete,newH_salon_ete,newH_chambre_ete,newnoise_ete]
result_ete=pd.concat(mergeData_ete,axis=1, join='inner')

mergeData_hiver=[newCO2_chambre_hiver,newCO2_salon_hiver,newT_salon_hiver,newT_chambre_hiver,newH_salon_hiver,newH_chambre_hiver,newnoise_hiver]
result_hiver=pd.concat(mergeData_hiver,axis=1, join='inner')

print (result_ete)
print(result_hiver)

result_ete.to_excel('data_summer_.xlsx')
result_hiver.to_excel('data_winter_.xlsx')